routes/web.php
<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', function () {

    return redirect()->route('login');
});


// Guest Users
Route::middleware(['guest','PreventBackHistory'])->group(function()
{
    Route::get('/', [App\Http\Controllers\Admin\AuthController::class, 'showLogin'])->name('/');
    Route::get('login', [App\Http\Controllers\Admin\AuthController::class, 'showLogin'] )->name('login');
    Route::post('login', [App\Http\Controllers\Admin\AuthController::class, 'login'])->name('signin');

});



// Authenticated users
Route::middleware(['auth','PreventBackHistory'])->group(function()
{

    // Auth Routes
    Route::get('edit-profile', [App\Http\Controllers\Admin\DashboardController::class, 'editProfile'] )->name('edit-profile');
    Route::get('home', fn () => redirect()->route('dashboard'))->name('home');
    Route::post('logout', [App\Http\Controllers\Admin\AuthController::class, 'Logout'])->name('logout');
    Route::get('show-change-password', [App\Http\Controllers\Admin\AuthController::class, 'showChangePassword'] )->name('show-change-password');
    Route::post('change-password', [App\Http\Controllers\Admin\AuthController::class, 'changePassword'] )->name('change-password');



    // Dashboard routes
    Route::get('dashboard', [App\Http\Controllers\Admin\DashboardController::class, 'index'])->name('dashboard');



    // Manual Sync Attendance
    Route::get('manual-sync', [App\Http\Controllers\Admin\MaualSyncController ::class, 'index'] )->name('manual-sync.index');
    Route::post('manual-sync', [App\Http\Controllers\Admin\MaualSyncController::class, 'addManualSync'] )->name('manual-sync.store');
    Route::post('check-sync-status', [App\Http\Controllers\Admin\MaualSyncController::class, 'checkSyncStatus'] )->name('check-sync-status');



    // Masters routes
    Route::resource('departments', App\Http\Controllers\Admin\Masters\DepartmentController::class );
    Route::get('departments/{department}/sub_departments', [App\Http\Controllers\Admin\Masters\DepartmentController::class, 'getSubDepartments'] )->name('departments.sub_departments');
    Route::resource('sub-departments', App\Http\Controllers\Admin\Masters\SubDepartmentController::class );
    Route::resource('wards', App\Http\Controllers\Admin\Masters\WardController::class );
    Route::get('wards/{ward}/departments', [App\Http\Controllers\Admin\Masters\DepartmentController::class, 'getWardDepartments'] )->name('wards.departments');
    Route::resource('clas', App\Http\Controllers\Admin\Masters\ClasController::class );
    Route::resource('designations', App\Http\Controllers\Admin\Masters\DesignationController::class );
    Route::resource('holidays', App\Http\Controllers\Admin\Masters\HolidayController::class );
    Route::resource('leave_types', App\Http\Controllers\Admin\Masters\LeaveTypeController::class );
    Route::resource('leaves', App\Http\Controllers\Admin\Masters\LeaveController::class );
    Route::resource('shifts', App\Http\Controllers\Admin\Masters\ShiftController::class );
    Route::resource('devices', App\Http\Controllers\Admin\Masters\DeviceController::class );


    // Users Roles n Permissions
    Route::resource('users', App\Http\Controllers\Admin\UserController::class );
    Route::get('users/{user}/toggle', [App\Http\Controllers\Admin\UserController::class, 'toggle' ])->name('users.toggle');
    Route::put('users/{user}/change-password', [App\Http\Controllers\Admin\UserController::class, 'changePassword' ])->name('users.change-password');
    Route::get('users/{user}/get-role', [App\Http\Controllers\Admin\UserController::class, 'getRole' ])->name('users.get-role');
    Route::put('users/{user}/assign-role', [App\Http\Controllers\Admin\UserController::class, 'assignRole' ])->name('users.assign-role');
    Route::resource('roles', App\Http\Controllers\Admin\RoleController::class );


    // Employees Routes
    Route::resource('employees', App\Http\Controllers\Admin\EmployeeController::class );
    Route::get('employees/{employee:emp_code}/info', [App\Http\Controllers\Admin\EmployeeController::class, 'fetchInfo'] )->name('employees.info');


    // Punches Routes
    Route::resource('punches', App\Http\Controllers\Admin\PunchController::class );
    Route::get('punches/{punch}/toggle', [App\Http\Controllers\Admin\PunchController::class, 'toggle' ])->name('punches.toggle');


    // Leaves Routes
    Route::resource('leave-requests', App\Http\Controllers\Admin\LeaveRequestController::class );
    Route::put('leave-requests/{leave_request}/change-request', [App\Http\Controllers\Admin\LeaveRequestController::class, 'changeRequest'] )->name('leave-requests.change-request');
    Route::get('active-medical-leave-requests', [App\Http\Controllers\Admin\LeaveRequestController::class, 'activeMedicalLeaveRequest'] )->name('leave-requests.active-medical-leave');
    Route::get('completed-medical-leave-requests', [App\Http\Controllers\Admin\LeaveRequestController::class, 'completedMedicalLeaveRequest'] )->name('leave-requests.completed-medical-leave');
    Route::get('leave-applications', [App\Http\Controllers\Admin\LeaveRequestController::class, 'pendingLeaveRequest'] )->name('leave-requests.application');


    // Employee Shifts
    Route::resource('rosters', App\Http\Controllers\Admin\RosterController::class );
    Route::get('sample_roster', [App\Http\Controllers\Admin\RosterController::class, 'downloadSample'] )->name('rosters.sample');
    Route::post('import_shift_roster', [App\Http\Controllers\Admin\RosterController::class, 'importShiftRoster'] )->name('rosters.import');


    // Reports
    Route::resource('reports', App\Http\Controllers\Admin\ReportController::class );
    Route::get('muster-report', [App\Http\Controllers\Admin\ReportController::class, 'musterReport'] )->name('reports.muster');
    Route::get('reports/get/month-wise-date', [App\Http\Controllers\Admin\ReportController::class, 'monthWiseDate'] )->name('reports.dates');
    Route::get('device_log_report', [App\Http\Controllers\Admin\ReportController::class, 'deviceLogReport'])->name('dashboard.device-log-report');
    Route::get('daily_attendance_report', [App\Http\Controllers\Admin\ReportController::class, 'dailyAttendanceReport'])->name('dashboard.daily-attendance-report');
    Route::get('department_wise_report', [App\Http\Controllers\Admin\ReportController::class, 'departmentWiseReport'])->name('dashboard.department-wise-report');
    Route::get('todays_present_report', [App\Http\Controllers\Admin\ReportController::class, 'todaysPresentReport'])->name('dashboard.todays-present-report');
    Route::get('todays_absent_report', [App\Http\Controllers\Admin\ReportController::class, 'todaysAbsentReport'])->name('dashboard.todays-absent-report');
    Route::get('shift_wise_employee/{shift_id}', [App\Http\Controllers\Admin\ReportController::class, 'shiftWiseEmployees'])->name('dashboard.shift-wise-employee');
    Route::get('todays_leave_bifurcation', [App\Http\Controllers\Admin\ReportController::class, 'todaysLeaveBifurcation'])->name('dashboard.todays-leave-bifurcation');
    Route::get('month_wise_latemark', [App\Http\Controllers\Admin\ReportController::class, 'monthWiseLatemark'])->name('dashboard.month-wise-latemark');
    Route::get('month_wise_absent', [App\Http\Controllers\Admin\ReportController::class, 'monthWiseAbsent'])->name('dashboard.month-wise-absent');
    Route::get('employee_wise_report', [App\Http\Controllers\Admin\ReportController::class, 'employeeWiseReport'])->name('dashboard.employee-wise-report');


});




Route::prefix('employee')->name('employee.')->group(function(){

    // Guest employees
    Route::middleware(['employee.guest','PreventBackHistory'])->group(function()
    {
        Route::get('/', fn()=> redirect()->route('login', ['device_type'=> 'mobile']) )->name('login');
        Route::get('/register', [App\Http\Controllers\Employee\AuthController::class, 'showRegister'])->name('register');
        Route::post('/emp-info', [App\Http\Controllers\Employee\AuthController::class, 'searchEmployeeCode'])->name('emp-info');
        Route::post('/register', [App\Http\Controllers\Employee\AuthController::class, 'register'])->name('signup');
    });

    // Authenticated employees
    Route::middleware(['employee.auth','PreventBackHistory'])->group(function()
    {
        Route::get('/home', [App\Http\Controllers\Employee\HomeController::class, 'index'])->name('home');
        Route::post('/employee-logout', [App\Http\Controllers\Employee\HomeController::class, 'logout'])->name('logout');
        Route::get('/delete-account', [App\Http\Controllers\Employee\HomeController::class, 'deleteAccount'])->name('delete-account');

        Route::get('show-change-password', [App\Http\Controllers\Employee\HomeController::class, 'showChangePassword'] )->name('show-change-password');
        Route::post('change-password', [App\Http\Controllers\Employee\HomeController::class, 'changePassword'] )->name('change-password');
    });

});

Route::get('/privacy-policy', [App\Http\Controllers\Employee\HomeController::class, 'privacyPolicy'])->name('privacy-policy');






Route::get('/import-department', function(){
    Artisan::call('department:import');
    return dd(Artisan::output());
});
Route::get('/import-punches', function(){
    Artisan::call('punches:import');
    return dd(Artisan::output());
});
Route::get('/import-employees', function(){
    Artisan::call('employees:import');
    return dd(Artisan::output());
});

Route::get('/php', function(Request $request){
    // if( !auth()->check() )

app/Http/Controllers/Admin/DashboardController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Department;
use App\Models\Holiday;
use App\Models\Punch;
use App\Models\User;
use Illuminate\Http\Request;
use App\Models\Ward;
use Carbon\Carbon;


class DashboardController extends Controller
{
    public function index(Request $request)
    {
        $authUser = auth()->user();
        $is_admin = $authUser->hasRole(['Admin', 'Super Admin']) ? true : false;
        $ward = $request->ward;

        $totalEmployees = User::when(!$is_admin, fn($qr) => $qr->where('department_id', $authUser->department_id) )
                                    ->where('tenant_id', $authUser->tenant_id)
                                    ->when($ward, fn($qr) => $qr->where('ward_id', $ward) )
                                    ->whereIsEmployee('1')
                                    ->count();

        if($is_admin)
            $totalDepartments = Department::whereDepartmentId(null)->where('tenant_id', $authUser->tenant_id)->when($ward, fn($qr) => $qr->where('ward_id', $ward) )->count();
        else
            $totalDepartments = 1;

        $totalHolidays = Holiday::where('year', date('Y'))->where('tenant_id', $authUser->tenant_id)->count();
        $totalWards = Ward::withCount('users')->where('tenant_id', auth()->user()->tenant_id)->get();

        $todaysDate = Carbon::today()->toDateString();
        $backDate = Carbon::today()->subDay()->toDateString();

        $punchData = Punch::whereIn('punch_date', [$todaysDate, $backDate])
                            ->select('id', 'emp_code', 'check_in', 'check_out', 'duration', 'punch_date', 'is_latemark', 'is_latemark_updated', 'punch_by', 'type', 'leave_type_id')
                            ->withWhereHas('user', fn($q)=>
                                        $q->when(!$is_admin, fn($qr) => $qr->where('department_id', $authUser->department_id) )
                                        ->when($is_admin && $ward, fn($qr) => $qr->where('ward_id', $ward))
                                        ->where('tenant_id', $authUser->tenant_id)
                            )
                            ->latest()->get();

        $todayPunchData = $punchData->where('punch_date', '>=', Carbon::parse($todaysDate)->toDateString());

        // $repeatedlyLatemark = User::withCount(['punches'=> fn ($q)=>
        //                                             $q->where('is_latemark', '1')
        //                                                 ->whereDate('punch_date', '>=', Carbon::today()->startOfMonth()->toDateString())
        //                                                 ->whereDate('punch_date', '<=', Carbon::today()->endOfMonth()->toDateString())
        //                                             ])
        //                                         ->having('punches_count', '>', '3')
        //                                         ->when(!$is_admin, fn($q)=> $q->where('department_id', $authUser->department_id) )
        //                                         ->when($ward, fn($q)=> $q->where('ward_id', $ward))
        //                                         ->count();
        // dd($repeatedlyLatemark);

        return view('admin.dashboard.index')->with([
                        'is_admin' => $is_admin,
                        'totalEmployees' => $totalEmployees,
                        'totalDepartments'=> $totalDepartments,
                        'totalHolidays'=> $totalHolidays,
                        'totalWards'=> $totalWards,
                        'todaysDate'=> $todaysDate,
                        'backDate'=> $backDate,
                        'punchData'=> $punchData,
                        'todayPunchData'=> $todayPunchData,
                        // 'shiftWiseData'=> $shiftWiseData,
                    ]);
    }



}

resources/views/admin/dashboard/department-wise-attendance-report.blade.php
<x-admin.admin-layout>
    <x-slot name="title">{{ auth()->user()->tenant_name }} - Department wise attendance</x-slot>

    <div class="page-body">
        <div class="container-fluid">
            <div class="page-header py-3">


                <div class="row">
                    <div class="col-sm-12">
                        <h3>Department wise attendance</h3>

                        @if(Session::has('success'))
                            <div class="alert alert-success text-center">
                                {{Session::get('success')}}
                            </div>
                        @endif

                    </div>
                    <div class="col-sm-6">
                    </div>
                </div>
            </div>
        </div>
        <!-- Container-fluid starts-->
        <div class="container-fluid support-ticket">
            <div class="row">

                <div class="col-sm-12">
                    <div class="card">

                        <div class="card-body">
                            <div class="row">
                                <div class="col-sm-6">
                                    <div class="">
                                        {{-- <button id="addToTable" class="btn btn-primary">Manual Attendance <i class="fa fa-plus"></i></button> --}}
                                        <button id="btnCancel" class="btn btn-danger" style="display:none;">Cancel</button>
                                    </div>
                                </div>
                            </div>
                            <div class="table-responsive">
                                <table class="display table-bordered" id="datatable-tabletools">
                                    <thead>
                                        <tr>
                                            <th>Sr No</th>
                                            <th>Department</th>
                                            <th>Total Employee</th>
                                            <th>Today's Present</th>
                                            <th>Today's Absent</th>
                                            <th>Progress Bar</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @forelse ($data as $value)
                                            <tr>
                                                <td>{{ $loop->iteration }}</td>
                                                <td>{{ $value->name }}</td>
                                                <td>{{ $value->users_count }}</td>
                                                <td>{{ $value->present_count }}</td>
                                                <td>{{ $value->users_count - $value->present_count }}</td>
                                                <td>
                                                    <div class="progress">
                                                        <div class="progress-bar-animated bg-primary progress-bar-striped" role="progressbar" style="width: {{ $value->users_count ? floor(($value->present_count / $value->users_count) * 100) : '0' }}%" aria-valuenow="{{ $value->users_count ? floor(($value->present_count / $value->users_count) * 100) : '0' }}" aria-valuemin="0" aria-valuemax="100"> &nbsp;&nbsp; {{ $value->users_count ? floor(($value->present_count / $value->users_count) * 100) : ' 0' }}% </div>
                                                    </div>
                                                </td>
                                                {{-- <td>{{  }}</td> --}}
                                            </tr>
                                        @empty
                                            <tr>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                            </tr>
                                        @endforelse
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>

            </div>
        </div>
        <!-- Container-fluid Ends-->
    </div>



</x-admin.admin-layout>



<!-- Get Sub departments -->
<script>
    $("select[name='department_id']").change( function(e) {
        e.preventDefault();

        var model_id = $(this).val();
        var url = "{{ route('departments.sub_departments', ':model_id') }}";

        $.ajax({
            url: url.replace(':model_id', model_id),
            type: 'GET',
            data: {
                '_token': "{{ csrf_token() }}"
            },
            success: function(data, textStatus, jqXHR)
            {
                if (!data.error)
                {
                    $("select[name='sub_department_id']").html(data.subDepartmentHtml);
                } else {
                    swal("Error!", data.error, "error");
                }
            },
            error: function(error, jqXHR, textStatus, errorThrown) {
                swal("Error!", "Some thing went wrong", "error");
            },
        });
    });
</script>


<!-- Show Details -->
<script>
    $("#datatable-tabletools").on("click", ".emp-more-info", function(e) {
        e.preventDefault();
        var model_id = $(this).attr("data-id");
        var url = "{{ route('punches.show', ':model_id') }}";

        $.ajax({
            url: url.replace(':model_id', model_id),
            type: 'GET',
            data: {
                '_token': "{{ csrf_token() }}"
            },
            success: function(data, textStatus, jqXHR)
            {
                console.log(data);
                if (data.result == 1)
                {
                    $("#more-info-modal").modal('show');
                    $("#empMoreInfo").html(data.html);
                }
                else
                {
                    swal("Error!", "Some thing went wrong", "error");
                }
            },
            error: function(error, jqXHR, textStatus, errorThrown) {
                swal("Error!", "Some thing went wrong", "error");
            },
        });
    });
</script>


{{-- Get month wise date --}}
<script>
    $(document).ready(function(){

        $("select[name='month']").change(function(e){
            e.preventDefault();
            var month = $("select[name='month']").val();
            var year = $("select[name='year']").val();

            if(month != '')
            {
                $.ajax({
                    url: "{{ route('reports.dates') }}",
                    type: 'GET',
                    data: {
                        'month': month,
                        'year': year,
                        '_token': "{{ csrf_token() }}"
                    },
                    success: function(data, textStatus, jqXHR)
                    {
                        if (!data.error)
                        {
                            $("input[name='from_date']").val(data.fromDate);
                            $("input[name='to_date']").val(data.toDate);
                        } else {
                            swal("Error!", data.error, "error");
                        }
                    },
                    error: function(error, jqXHR, textStatus, errorThrown) {
                        swal("Error!", "Some thing went wrong", "error");
                    },
                });
            }
            else
            {
            alert("please select month");
            }
        });

    });
</script>

<!-- Get Ward wise departments -->
<script>
    $("select[name='ward']").change( function(e) {
        e.preventDefault();

        var model_id = $(this).val();
        var url = "{{ route('wards.departments', ':model_id') }}";

        $.ajax({
            url: url.replace(':model_id', model_id),
            type: 'GET',
            data: {
                '_token': "{{ csrf_token() }}"
            },
            success: function(data, textStatus, jqXHR)
            {
                if (!data.error)
                {
                    $("select[name='department']").html(data.departmentHtml);
                } else {
                    swal("Error!", data.error, "error");
                }
            },
            error: function(error, jqXHR, textStatus, errorThrown) {
                swal("Error!", "Some thing went wrong", "error");
            },
        });
    });
</script>